'use strict';
module.exports = function generate_errorMessage(it, $keyword, $ruleType) {
  var out = ' ';
  var $lvl = it.level;
  var $dataLvl = it.dataLevel;
  var $schema = it.schema[$keyword];
  var $schemaPath = it.schemaPath + it.util.getProperty($keyword);
  var $errSchemaPath = it.errSchemaPath + '/' + $keyword;
  var $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || '');
  if (it.createErrors !== false) {
    out += ' if (errors > 0) { ';
    var $dataPath = '_em_dataPath' + $lvl,
      $i = '_em_i' + $lvl,
      $key = '_em_key' + $lvl,
      $err = '_em_err' + $lvl,
      $child = '_em_child' + $lvl,
      $matches = '_em_matches' + $lvl,
      $isArray = '_em_isArray' + $lvl,
      $errors = '_em_errors' + $lvl,
      $errSchemaPathString = it.util.toQuotedString(it.errSchemaPath);
    out += ' var ' + ($dataPath) + ' = (dataPath || \'\') + ' + (it.errorPath) + '; var ' + ($i) + ', ' + ($err) + ', ' + ($errors) + '; ';
    if (typeof $schema == 'string') {
      out += ' ' + ($i) + ' = 0; ' + ($errors) + ' = []; while (' + ($i) + ' < errors) { ' + ($err) + ' = vErrors[' + ($i) + ']; if ( ' + ($err) + '.keyword != \'' + ($keyword) + '\' && (' + ($err) + '.dataPath == ' + ($dataPath) + ' || (' + ($err) + '.dataPath.indexOf(' + ($dataPath) + ') == 0 && ' + ($err) + '.dataPath[' + ($dataPath) + '.length] == \'/\')) && ' + ($err) + '.schemaPath.indexOf(' + ($errSchemaPathString) + ') == 0 && ' + ($err) + '.schemaPath[' + (it.errSchemaPath.length) + '] == \'/\') { ' + ($errors) + '.push(' + ($err) + '); vErrors.splice(' + ($i) + ', 1); errors--; } else { ' + ($i) + '++; } } if (' + ($errors) + '.length) { var err = { keyword: \'' + ($keyword) + '\' , dataPath: ' + ($dataPath) + ' , schemaPath: ' + ($errSchemaPathString) + ' + \'/' + ($keyword) + '\' , params: { errors: ' + ($errors) + ' } , message: ' + (it.util.toQuotedString($schema)) + ' ';
      if (it.opts.verbose) {
        out += ' , schema: ' + (it.util.toQuotedString($schema)) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' };  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; } ';
    } else {
      var $config = it.self.getKeyword($keyword).config,
        $keywordErrors = {},
        $childErrors = {
          properties: {},
          items: {}
        },
        $hasProperties, $hasItems;
      for (var $k in $schema) {
        switch ($k) {
          case 'properties':
            for (var $prop in $schema.properties) {
              $hasProperties = true;
              $childErrors.properties[$prop] = [];
            }
            break;
          case 'items':
            for (var $item = 0; $item < $schema.items.length; $item++) {
              $hasItems = true;
              $childErrors.items[$item] = [];
            }
            break;
          default:
            $keywordErrors[$k] = [];
        }
      }
      if (Object.keys($keywordErrors).length) {
        out += ' ' + ($i) + ' = 0; ' + ($errors) + ' = ' + (JSON.stringify($keywordErrors)) + '; while (' + ($i) + ' < errors) { ' + ($err) + ' = vErrors[' + ($i) + ']; if ( ' + ($err) + '.keyword in ' + ($errors) + ' && ' + ($err) + '.dataPath == ' + ($dataPath) + ' && ' + ($err) + '.schemaPath.indexOf(' + ($errSchemaPathString) + ') == 0 && /^\\/[^\\/]*$/.test(' + ($err) + '.schemaPath.slice(' + (it.errSchemaPath.length) + '))) { ' + ($errors) + '[' + ($err) + '.keyword].push(' + ($err) + '); vErrors.splice(' + ($i) + ', 1); errors--; } else { ' + ($i) + '++; } } for (var ' + ($key) + ' in ' + ($errors) + ') { if (' + ($errors) + '[' + ($key) + '].length) { var err = { keyword: \'' + ($keyword) + '\' , dataPath: ' + ($dataPath) + ' , schemaPath: ' + ($errSchemaPathString) + ' + \'/' + ($keyword) + '\' , params: { errors: ' + ($errors) + '[' + ($key) + '] } , message: validate.schema' + ($schemaPath) + '[' + ($key) + '] ';
        if (it.opts.verbose) {
          out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
        }
        out += ' };  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; } } ';
      }
      if ($hasProperties || $hasItems) {
        out += ' var ' + ($isArray) + ' = Array.isArray(' + ($data) + '); if (';
        if ($hasProperties && $hasItems) {
          out += ' typeof ' + ($data) + ' == \'object\' ';
        } else if ($hasProperties) {
          out += ' typeof ' + ($data) + ' == \'object\' && !' + ($isArray) + ' ';
        } else {
          out += ' ' + ($isArray) + ' ';
        }
        out += ') { ' + ($i) + ' = 0; ' + ($errors) + ' = ';
        if ($hasProperties && $hasItems) {
          out += ' ' + ($isArray) + ' ? ' + (JSON.stringify($childErrors.items)) + ' : ' + (JSON.stringify($childErrors.properties)) + ' ';
        } else if ($hasProperties) {
          out += ' ' + (JSON.stringify($childErrors.properties)) + ' ';
        } else {
          out += ' ' + (JSON.stringify($childErrors.items)) + ' ';
        }
        out += '; var ' + ($child) + ', ' + ($matches) + '; while (' + ($i) + ' < errors) { ' + ($err) + ' = vErrors[' + ($i) + ']; if ( ' + ($err) + '.keyword != \'' + ($keyword) + '\' && ' + ($err) + '.dataPath.indexOf(' + ($dataPath) + ') == 0 && (' + ($matches) + ' = ' + ($err) + '.dataPath.slice(' + ($dataPath) + '.length).match(/^\\/([^\\/]*)(?:\\/|$)/), ' + ($child) + ' = ' + ($matches) + ' && ' + ($matches) + '[1].replace(/~1/g, \'/\').replace(/~0/g, \'~\') ) !== undefined && ' + ($child) + ' in ' + ($errors) + ') { ' + ($errors) + '[' + ($child) + '].push(' + ($err) + '); vErrors.splice(' + ($i) + ', 1); errors--; } else { ' + ($i) + '++; } } for (var ' + ($key) + ' in ' + ($errors) + ') { if (' + ($errors) + '[' + ($key) + '].length) { var err = { keyword: \'' + ($keyword) + '\' , dataPath: ' + ($dataPath) + ' + \'/\' + ' + ($key) + '.replace(/~/g, \'~0\').replace(/\\//g, \'~1\') , schemaPath: ' + ($errSchemaPathString) + ' + \'/' + ($keyword) + '\' , params: { errors: ' + ($errors) + '[' + ($key) + '] } , message: validate.schema' + ($schemaPath) + ' ';
        if ($hasProperties && $hasItems) {
          out += ' [' + ($isArray) + ' ? \'items\' : \'properties\'] ';
        } else if ($hasProperties) {
          out += ' .properties ';
        } else {
          out += ' .items ';
        }
        out += ' [' + ($key) + '] ';
        if (it.opts.verbose) {
          out += ' , schema: validate.schema' + ($schemaPath) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
        }
        out += ' };  if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; } } } ';
      }
    }
    out += ' }';
  }
  return out;
}
